=== debian/changelog ===
jdupes (1.31.1-1) unstable; urgency=medium

  * New upstream version 1.31.1.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Wed, 15 Oct 2025 23:36:27 -0300

jdupes (1.30.0-3) unstable; urgency=medium

  * debian/tests/: created another CI test for #1063079.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Sat, 04 Oct 2025 17:43:47 -0300
