=== debian/control ===
Source: jdupes
Section: utils
Priority: optional
Maintainer: Joao Eriberto Mota Filho <eriberto@debian.org>
Build-Depends: debhelper-compat (= 13), libjodycode-dev (>= 4.0.1-6)
Standards-Version: 4.7.2
Homepage: https://www.jdupes.com/
Vcs-Browser: https://salsa.debian.org/debian/jdupes
Vcs-Git: https://salsa.debian.org/debian/jdupes.git

Package: jdupes
Architecture: any
Multi-Arch: foreign
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: identify and delete or link duplicate files
 jdupes is a program based in fdupes. The main goal of jdupes is identify
 and taking actions upon duplicate files. In comparison with fdupes, jdupes
 is heavily modified from and improved.
 .
 The biggest reason to use jdupes is raw speed. In testing on various data
 sets, jdupes is over 7 times faster than fdupes-1.51 on average.
 .
 Code in jdupes is written with data loss avoidance as the highest priority.
 If a choice must be made between being aggressive or careful, the careful
 way is always chosen.
 .
 jdupes includes features that are not found in fdupes. Examples of such
 features include btrfs block-level deduplication and control over which
 file is kept when a match set is automatically deleted. jdupes is not
 afraid of dropping features of low value; a prime example is the -1 switch
 which outputs all matches in a set on one line, a feature which was found
 to be useless in real-world tests and therefore thrown out.
 .
 jdupes can convert duplicate files in hardlinks or relative softlinks. It
 is useful in several scenarios, as in Debian packaging, to create relative
 symlinks to lots of duplicate files (it will substitute rdfind + symlinks
 commands, used to same purpose, when solving lintian duplicate-files).
 .
 Packages build for Linux versions have support to btrfs filesystem.
