=== debian/watch ===
version=4
https://codeberg.org/jbruchon/jdupes/releases archive/v?(\d\S+)\.tar\.(?:bz2|gz|xz)
